<template>
  <v-card>
    <!-- Delivery status -->
    <v-card-title class="primary--text">
      Status: {{ delivery.status.toUpperCase() }}
    </v-card-title>

    <!-- Restaurant name -->
    <v-card-title> From: {{ delivery.restaurant.name }} </v-card-title>

    <!-- Restaurant address -->
    <v-card-subtitle>{{
      delivery.restaurant.address.street +
      ', ' +
      delivery.restaurant.address.postalCode +
      ' ' +
      delivery.restaurant.address.city +
      ', ' +
      delivery.restaurant.address.country
    }}</v-card-subtitle>

    <!-- Consumer name -->
    <v-card-title>
      To: {{ delivery.consumer.firstName + ' ' + delivery.consumer.lastName }}
    </v-card-title>

    <!-- Consumer address -->
    <v-card-subtitle>{{
      delivery.consumer.address.street +
      ', ' +
      delivery.consumer.address.postalCode +
      ' ' +
      delivery.consumer.address.city +
      ', ' +
      delivery.consumer.address.country
    }}</v-card-subtitle>

    <!-- Income -->
    <v-card-title> Income: ${{ delivery.price.delivery || 10 }} </v-card-title>

    <!-- Order items -->
    <v-card-title v-if="delivery.status !== 'pending confirmation'">
      Items:
    </v-card-title>
    <v-card-text v-if="delivery.status !== 'pending confirmation'">
      <v-list dense>
        <v-list-item v-for="item in delivery.items" :key="item.name">
          <v-list-item-content>
            <v-list-item-title>{{ item.name }}</v-list-item-title>
            <v-list-item-subtitle>{{
              'x ' + item.quantity
            }}</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <!-- Notes -->
      <p
        v-if="
          delivery.deliveryNotes && delivery.status !== 'pending confirmation'
        "
      >
        Notes: {{ delivery.deliveryNotes }}
      </p>

      <!-- Dates -->
      <p v-if="['delivering', 'delivered'].includes(delivery.status)">
        Picked up:
        {{ new Date(delivery.timestamps.pickedUp * 1000).toUTCString() }}
      </p>
      <p v-if="delivery.status === 'delivered'">
        Delivered:
        {{ new Date(delivery.timestamps.delivered * 1000).toUTCString() }}
      </p>
    </v-card-text>
    <v-card-actions>
      <v-btn
        v-if="delivery.status === 'prepared'"
        color="primary"
        @click="pickUp"
      >
        I picked it up!
      </v-btn>
      <v-btn
        v-if="delivery.status === 'pending confirmation'"
        color="primary"
        @click="accept"
      >
        Accept delivery
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  props: {
    delivery: {
      type: Object,
      required: true,
    },
  },
  methods: {
    pickUp() {
      // TODO:
    },
    accept() {
      // TODO:
    },
  },
})
</script>
